#ifndef _ROW_ACL_H_

#include <postgres.h>
#include <fmgr.h>

typedef int16 row_acl;

#define ROW_ACL_LENGTH		sizeof(row_acl)
#define ROW_ACL_COUNT		ROW_ACL_LENGTH * 8
#define ROW_ACL_STR_LENGTH	(ROW_ACL_COUNT + 1)

#define ROW_ACL_USER_READ	16384	/* 10000 00000 00000 */
#define ROW_ACL_USER_WRITE	8192	/* 01000 00000 00000 */
#define ROW_ACL_USER_DELETE	4096	/* 00100 00000 00000 */
#define ROW_ACL_USER_INSERT	2048	/* 00010 00000 00000 */
#define ROW_ACL_USER_EXEC	1024	/* 00001 00000 00000 */
#define ROW_ACL_USER_ALL	31744	/* 11111 00000 00000 */

#define ROW_ACL_GROUP_READ	512	/* 00000 10000 00000 */
#define ROW_ACL_GROUP_WRITE	256	/* 00000 01000 00000 */
#define ROW_ACL_GROUP_DELETE	128	/* 00000 00100 00000 */
#define ROW_ACL_GROUP_INSERT	64	/* 00000 00010 00000 */
#define ROW_ACL_GROUP_EXEC	32	/* 00000 00001 00000 */
#define ROW_ACL_GROUP_ALL	992	/* 00000 11111 00000 */

#define ROW_ACL_OTHER_READ	16	/* 00000 00000 10000 */
#define ROW_ACL_OTHER_WRITE	8	/* 00000 00000 01000 */
#define ROW_ACL_OTHER_DELETE	4	/* 00000 00000 00100 */
#define ROW_ACL_OTHER_INSERT	2	/* 00000 00000 00010 */
#define ROW_ACL_OTHER_EXEC	1	/* 00000 00000 00001 */
#define ROW_ACL_OTHER_ALL	31	/* 00000 00000 11111 */

#define ROW_ACL_NOTHING		0
#define ROW_ACL_ALL		((1 << ROW_ACL_COUNT) - 1)

#define ROW_SHL_USR		10
#define ROW_SHL_GRP		5

#define ROW_USER_NOAUTH		0
#define ROW_USER_ROOT		1

#define _ROW_ACL_H_
#endif

